module Qt
	module Internal
	
	Classes = {}
	CppName = {}
	IdClass = Array.new

#		Wrapper class to denote an argument is a 'reference', ie it is to be
#		supplied to a C++ method expecting a reference or a pointer to a 
#		primitive C++ type, such as 'int&' or 'int*'.
#		Example usage:
#			a = QApplication.new(ARGV, ref mynum);
#			...
#			if isRef(arg)
#		After the C++ method has been called, the QtRuby runtime will set
#		the ruby 'ref' arguments to the value of the C++ arg.
#			
		class Reference
			def value
				@value
			end
			def initialize(value)
				@value = value
			end
		end
		
		def ref(value)
			return Reference.new(value)
		end
		
		def init_class(c)
			classname = c.sub(/^Q/, 'Qt::')			
			classId = idClass(c)
			insert_pclassid(classname, classId)
			IdClass[classId] = classname
			CppName[classname] = c
			isa = getIsa(classId)
#			for parent in isa
#				puts parent
#			end
			klass = installautoload(classname)
			if klass != nil
				Classes[classname] = klass
			end
		end

		def find_class(classname)
			value = Classes[classname];
			return Classes[classname]
		end
				
		def do_method_missing(package, method, classId, *args)
			classname = CppName[classId]
			if method == "new"
				method = classname * 1
			end
						
			for arg in args
				if arg == nil or isObject(arg)
					method << "#"
				elsif isRef(arg)
					method << "?"
				else
					method << "$"
				end
			end
			methodId = findMethod(classname, method);
			setCurrentMethod(methodId)
			return 1
		end
		
		def init()
#    		installthis("__PACKAGE__")
    		installthis("Qt::base")
			classes = getClassList()
			for c in classes
				init_class(c)
			end
		end
	end
end

